# ShadingIn Struct Reference
[Data Structures]

Inheritance diagram for ShadingIn:

List of all members.

## Public Member Functions
| ShadingIn ()
## Static Public Member Functions
static void | Average (ShadingIn &out, ShadingIn &in1, ShadingIn &in2, ShadingFlags flags)
## Public Attributes
TVector3 | fPoint
| Surface point in Global Coordinates.
TVector3 | fGNormal
| Surface Normal in Global Coordinates.
TVector3 | fPointLoc
| Surface point in Local Coordinates.
TVector3 | fNormalLoc
| Surface Normal in Local Coordinates.
TVector2 | fUV
| u,v texture values
TVector3 | fPointx
TVector3 | fPointy
| Surface point derivatives in Global Coordinates.
TVector3 | fNormalx
TVector3 | fNormaly
| Surface Normal derivatives in Global Coordinates.
TVector2 | fUVx
TVector2 | fUVy
| texture derivatives
TVector3 | fPointLocx
TVector3 | fPointLocy
| Surface point derivatives in Local Coordinates.
TVector3 | fNormalLocx
TVector3 | fNormalLocy
| Surface Normal derivatives in Local Coordinates.
TVector3 | fIsoU
| U iso-parametric vector in Local Coordinates.
TVector3 | fIsoV
| V iso-parametric vector in Local Coordinates.
uint32 | fUVSpaceID
| UV Space ID; can use UVSpaceID enum.
boolean | fBumpOn
| global bump setting
EChannelMask | fChannelMask
| bit mask that determines which channel must be evaluated
uint32 | fCurrentCompletionMask
| Internal flags for shaders. Must be set to zero before calling DoShade.
I3DShInstance * | fInstance
| Used by ShadingMode to calculate bounding Box.
const UVSpaceInfo * | fUVInfo
| UV Space information (filled by I3DShInstance::DoShade()).
TVector3 | fSurfaceNormalLoc
| normal to the real geometry surface (before smoothing) in Local Coordinates
TVector3 | fGSurfaceNormal
| normal to the real geometry surface (before smoothing) in Global Coordinates

## Detailed Description

All the information that are passed to a shader for a given point.

## Constructor & Destructor Documentation

ShadingIn::ShadingIn | ( |  | ) | `[inline]`

## Member Function Documentation

void ShadingIn::Average | ( | ShadingIn & | out,
|  | ShadingIn & | in1,
|  | ShadingIn & | in2,
|  | ShadingFlags | flags |
| ) |  |  | `[inline, static]`

## Member Data Documentation

boolean ShadingIn::fBumpOn

global bump setting

EChannelMask ShadingIn::fChannelMask

bit mask that determines which channel must be evaluated

uint32 ShadingIn::fCurrentCompletionMask`[mutable]`

Internal flags for shaders. Must be set to zero before calling DoShade.

TVector3 ShadingIn::fGNormal

Surface Normal in Global Coordinates.

TVector3 ShadingIn::fGSurfaceNormal

normal to the real geometry surface (before smoothing) in Global Coordinates

I3DShInstance* ShadingIn::fInstance

Used by ShadingMode to calculate bounding Box.

TVector3 ShadingIn::fIsoU

U iso-parametric vector in Local Coordinates.

TVector3 ShadingIn::fIsoV

V iso-parametric vector in Local Coordinates.

TVector3 ShadingIn::fNormalLoc

Surface Normal in Local Coordinates.

TVector3 ShadingIn::fNormalLocx

TVector3 ShadingIn::fNormalLocy

Surface Normal derivatives in Local Coordinates.

TVector3 ShadingIn::fNormalx

TVector3 ShadingIn::fNormaly

Surface Normal derivatives in Global Coordinates.

TVector3 ShadingIn::fPoint

Surface point in Global Coordinates.

TVector3 ShadingIn::fPointLoc

Surface point in Local Coordinates.

TVector3 ShadingIn::fPointLocx

TVector3 ShadingIn::fPointLocy

Surface point derivatives in Local Coordinates.

TVector3 ShadingIn::fPointx

TVector3 ShadingIn::fPointy

Surface point derivatives in Global Coordinates.

TVector3 ShadingIn::fSurfaceNormalLoc

normal to the real geometry surface (before smoothing) in Local Coordinates

TVector2 ShadingIn::fUV

u,v texture values

const UVSpaceInfo* ShadingIn::fUVInfo

UV Space information (filled by I3DShInstance::DoShade()).

uint32 ShadingIn::fUVSpaceID

UV Space ID; can use UVSpaceID enum.

TVector2 ShadingIn::fUVx

TVector2 ShadingIn::fUVy

texture derivatives

The documentation for this struct was generated from the following file:

- ShaderTypes.h